module FakeBsmobil
  module Schema
    # generated from http://jsonschema.net/

    SESSION = '{"$schema":"http://json-schema.org/draft-04/schema#","id":"http://jsonschema.net","type":"object","properties":{"deviceInfo":{"id":"http://jsonschema.net/deviceInfo","type":"string"},"password":{"id":"http://jsonschema.net/password","type":"string"},"userName":{"id":"http://jsonschema.net/userName","type":"string"},"newDevice":{"id":"http://jsonschema.net/newDevice","type":"boolean"},"contract":{"id":"http://jsonschema.net/contract","type":"string"},"brand":{"id":"http://jsonschema.net/brand","type":"string"},"devicePrint":{"id":"http://jsonschema.net/devicePrint","type":"string"},"requestId":{"id":"http://jsonschema.net/requestId","type":"string"},"geolocationData":{"id":"http://jsonschema.net/geolocationData","type":"string"},"loginType":{"id":"http://jsonschema.net/loginType","type":"integer"}},"required":["deviceInfo","password","userName","newDevice","contract","brand","devicePrint","requestId","geolocationData","loginType"]}'.freeze
    USER = '{"$schema":"http://json-schema.org/draft-04/schema#","id":"http://jsonschema.net","type":"object","properties":{"user":{"id":"http://jsonschema.net/user","type":"object","properties":{"dni":{"id":"http://jsonschema.net/user/dni","type":"string"},"name":{"id":"http://jsonschema.net/user/name","type":"string"},"sex":{"id":"http://jsonschema.net/user/sex","type":"string"},"phoneNumber":{"id":"http://jsonschema.net/user/phoneNumber","type":"string"},"contractNumber":{"id":"http://jsonschema.net/user/contractNumber","type":"string"},"hasMoreContracts":{"id":"http://jsonschema.net/user/hasMoreContracts","type":"boolean"},"customization":{"id":"http://jsonschema.net/user/customization","type":"string"},"isNewUser":{"id":"http://jsonschema.net/user/isNewUser","type":"boolean"},"pendingSignOperations":{"id":"http://jsonschema.net/user/pendingSignOperations","type":"integer"},"personNumber":{"id":"http://jsonschema.net/user/personNumber","type":"string"},"idType":{"id":"http://jsonschema.net/user/idType","type":"string"},"loginType":{"id":"http://jsonschema.net/user/loginType","type":"integer"},"promoLayer":{"id":"http://jsonschema.net/user/promoLayer","type":"object","properties":{"code":{"id":"http://jsonschema.net/user/promoLayer/code","type":"string"},"url":{"id":"http://jsonschema.net/user/promoLayer/url","type":"string"},"nShows":{"id":"http://jsonschema.net/user/promoLayer/nShows","type":"integer"},"exist":{"id":"http://jsonschema.net/user/promoLayer/exist","type":"boolean"}}},"cardId":{"id":"http://jsonschema.net/user/cardId","type":"string"},"refreshActiveAgent":{"id":"http://jsonschema.net/user/refreshActiveAgent","type":"integer"},"signatureType":{"id":"http://jsonschema.net/user/signatureType","type":"string"},"vTPCInscriptionKey":{"id":"http://jsonschema.net/user/vTPCInscriptionKey","type":"string"}},"required":["dni","name","sex","phoneNumber","contractNumber","hasMoreContracts","customization","isNewUser","pendingSignOperations","personNumber","idType","loginType","promoLayer","cardId","refreshActiveAgent","signatureType","vTPCInscriptionKey"]},"isInputTypeNumberSupported":{"id":"http://jsonschema.net/isInputTypeNumberSupported","type":"boolean"}},"required":["user","isInputTypeNumberSupported"]}'.freeze
    CARD = '{"$schema":"http://json-schema.org/draft-04/schema#","id":"http://jsonschema.net","type":"object","properties":{"card":{"id":"http://jsonschema.net/card","type":"object","properties":{"alias":{"id":"http://jsonschema.net/card/alias","type":"string"},"stickerPan":{"id":"http://jsonschema.net/card/stickerPan","type":"string"},"availableBalance":{"id":"http://jsonschema.net/card/availableBalance","type":"object","properties":{"value":{"id":"http://jsonschema.net/card/availableBalance/value","type":"string"},"currency":{"id":"http://jsonschema.net/card/availableBalance/currency","type":"string"}},"additionalProperties":false},"bsprotect":{"id":"http://jsonschema.net/card/bsprotect","type":"string"},"expirationDate":{"id":"http://jsonschema.net/card/expirationDate","type":"null"},"isInternational":{"id":"http://jsonschema.net/card/isInternational","type":"boolean"},"description":{"id":"http://jsonschema.net/card/description","type":"string"},"dms":{"id":"http://jsonschema.net/card/dms","type":"string"},"activatedLE":{"id":"http://jsonschema.net/card/activatedLE","type":"string"},"isMarsans":{"id":"http://jsonschema.net/card/isMarsans","type":"boolean"},"phoneNumberChecked":{"id":"http://jsonschema.net/card/phoneNumberChecked","type":"string"},"type":{"id":"http://jsonschema.net/card/type","type":"string"},"number":{"id":"http://jsonschema.net/card/number","type":"string"},"shortDescription":{"id":"http://jsonschema.net/card/shortDescription","type":"string"},"isPrepaidAnonymous":{"id":"http://jsonschema.net/card/isPrepaidAnonymous","type":"boolean"},"isOwner":{"id":"http://jsonschema.net/card/isOwner","type":"boolean"},"productType":{"id":"http://jsonschema.net/card/productType","type":"string"},"operativeCode":{"id":"http://jsonschema.net/card/operativeCode","type":"string"},"name":{"id":"http://jsonschema.net/card/name","type":"string"},"entity":{"id":"http://jsonschema.net/card/entity","type":"string"},"phoneNumber":{"id":"http://jsonschema.net/card/phoneNumber","type":"string"},"dni":{"id":"http://jsonschema.net/card/dni","type":"string"},"stickerCard":{"id":"http://jsonschema.net/card/stickerCard","type":"boolean"},"mailChecked":{"id":"http://jsonschema.net/card/mailChecked","type":"boolean"},"contractCCC":{"id":"http://jsonschema.net/card/contractCCC","type":"string"},"indAlert":{"id":"http://jsonschema.net/card/indAlert","type":"string"},"isInternet":{"id":"http://jsonschema.net/card/isInternet","type":"boolean"},"codret":{"id":"http://jsonschema.net/card/codret","type":"string"},"cardType":{"id":"http://jsonschema.net/card/cardType","type":"object","properties":{"textColor":{"id":"http://jsonschema.net/card/cardType/textColor","type":"string"},"iconColor":{"id":"http://jsonschema.net/card/cardType/iconColor","type":"string"},"logo":{"id":"http://jsonschema.net/card/cardType/logo","type":"string"},"type":{"id":"http://jsonschema.net/card/cardType/type","type":"string"},"subtype":{"id":"http://jsonschema.net/card/cardType/subtype","type":"string"},"background":{"id":"http://jsonschema.net/card/cardType/background","type":"string"}},"additionalProperties":false},"cvv2":{"id":"http://jsonschema.net/card/cvv2","type":"string"},"selectableIndex":{"id":"http://jsonschema.net/card/selectableIndex","type":"string"},"canActivate":{"id":"http://jsonschema.net/card/canActivate","type":"boolean"},"mail":{"id":"http://jsonschema.net/card/mail","type":"string"},"reference":{"id":"http://jsonschema.net/card/reference","type":"string"},"balance":{"id":"http://jsonschema.net/card/balance","type":"object","properties":{"value":{"id":"http://jsonschema.net/card/balance/value","type":"string"},"currency":{"id":"http://jsonschema.net/card/balance/currency","type":"string"}},"additionalProperties":false},"isSticker":{"id":"http://jsonschema.net/card/isSticker","type":"boolean"},"realNumber":{"id":"http://jsonschema.net/card/realNumber","type":"string"},"numcard":{"id":"http://jsonschema.net/card/numcard","type":"string"}},"additionalProperties":false,"required":["realNumber"]},"paginator":{"id":"http://jsonschema.net/paginator","type":"object","properties":{"itemsPerPage":{"id":"http://jsonschema.net/paginator/itemsPerPage","type":"integer"},"order":{"id":"http://jsonschema.net/paginator/order","type":"string"},"totalItems":{"id":"http://jsonschema.net/paginator/totalItems","type":"integer"},"page":{"id":"http://jsonschema.net/paginator/page","type":"integer"}},"additionalProperties":false}},"additionalProperties":false,"required":["card"]}'.freeze
    ACCOUNT = '{"$schema":"http://json-schema.org/draft-04/schema#","id":"http://jsonschema.net","type":"object","properties":{"moreRequest":{"id":"http://jsonschema.net/moreRequest","type":"boolean"},"account":{"id":"http://jsonschema.net/account","type":"object","properties":{"description":{"id":"http://jsonschema.net/account/description","type":"string"},"mobileWarning":{"id":"http://jsonschema.net/account/mobileWarning","type":"string"},"amount":{"id":"http://jsonschema.net/account/amount","type":"object","properties":{"value":{"id":"http://jsonschema.net/account/amount/value","type":"string"},"currency":{"id":"http://jsonschema.net/account/amount/currency","type":"string"}},"additionalProperties":false},"owner":{"id":"http://jsonschema.net/account/owner","type":"string"},"product":{"id":"http://jsonschema.net/account/product","type":"string"},"isOwner":{"id":"http://jsonschema.net/account/isOwner","type":"boolean"},"iban":{"id":"http://jsonschema.net/account/iban","type":"string"},"isIberSecurities":{"id":"http://jsonschema.net/account/isIberSecurities","type":"boolean"},"availability":{"id":"http://jsonschema.net/account/availability","type":"string"},"alias":{"id":"http://jsonschema.net/account/alias","type":"string"},"number":{"id":"http://jsonschema.net/account/number","type":"string"},"bic":{"id":"http://jsonschema.net/account/bic","type":"string"},"isSBPManaged":{"id":"http://jsonschema.net/account/isSBPManaged","type":"boolean"},"joint":{"id":"http://jsonschema.net/account/joint","type":"string"},"numOwners":{"id":"http://jsonschema.net/account/numOwners","type":"integer"}},"additionalProperties":false},"dateFrom":{"id":"http://jsonschema.net/dateFrom","type":"string"},"dateTo":{"id":"http://jsonschema.net/dateTo","type":"string"}},"additionalProperties":false}'
  end
end
